--- rt_fifo_new.c.old	Sat May 10 13:09:14 1997
+++ rt_fifo_new.c	Sat May 10 13:48:47 1997
@@ -4,14 +4,22 @@
  * 1997, Michael Barabanov
  *
  * A lot of this code is stolen from fs/pipe.c
+ * 
+ *
+ * -- 05/10/1997 Procinfo support by clausi@chemie.fu-berlin.de
  *
  */
 
+#define PROC_INFO
+
 #include <linux/module.h>
 #include <linux/major.h>
 #include <linux/kernel.h>
 #include <linux/errno.h>
 #include <linux/malloc.h>
+#ifdef PROC_INFO
+#include <linux/proc_fs.h>
+#endif
 #include <linux/rtf.h>
 
 #include <asm/system.h>
@@ -23,6 +31,9 @@
 	int user_open;
 	int sleeps;
 	char *base;
+#ifdef PROC_INFO
+        int pid;
+#endif
 	int bufsize;
 	int start;
 	int len;
@@ -55,6 +66,56 @@
 #define RTF_MAX_WCHUNK(minor)	(RTF_BUF(minor) - RTF_END(minor))
 
 
+
+#ifdef PROC_INFO
+
+#define RTF_PID(minor)   (RTF_ADDR(minor)->pid) 
+
+
+extern int rtf_procinfo (char *buf, char **start, off_t fpos, 
+                                int length, int dummy);
+
+
+static struct proc_dir_entry    rtf_proc_entry = {
+0, 6, "RTfifo", S_IFREG | S_IRUGO, 1, 0, 0, 0, 0, rtf_procinfo };
+
+
+void register_procinfo(void) {
+     rtf_proc_entry.name    = "RTfifo";
+     rtf_proc_entry.namelen = strlen("RTfifo");
+     proc_register_dynamic(&proc_root, &rtf_proc_entry);
+}
+
+void unregister_procinfo(void) {
+     proc_unregister(&proc_root,
+                     rtf_proc_entry.low_ino );
+
+}
+
+int rtf_procinfo (char *buf, char **start, off_t fpos, 
+                                int length, int dummy)
+{
+
+     char *p;
+     int i;
+     p = buf; 
+     /* print header */
+     p += sprintf(p,"fifo# \tUS \tsize \tpid\n");
+     for (i = 0; i < RTF_NO; i++) {
+		if( RTF_OPEN(i) )  /* print detailed information */
+		       p += sprintf(p,"%d \t%c%c \t%d \t%d \n",i,
+				    (RTF_USER_OPEN(i)?'u':'-'),
+				    (RTF_SLEEPS(i)?'S':'-'),
+				    RTF_BUF(i),
+				    (RTF_USER_OPEN(i)? RTF_PID(i):-1)
+				    );
+     }       
+     return p - buf;
+
+}
+#endif /* PROC_INFO */
+
+
 static void rtf_wake_up(void *p)
 {
 	struct rt_fifo_struct *fifo_ptr = (struct rt_fifo_struct *) p;
@@ -244,6 +305,9 @@
 		return -EBUSY;
 	}
 	RTF_USER_OPEN(minor) = 1;
+#ifdef PROC_INFO
+	RTF_PID(minor) = current->pid; 
+#endif
 
 	MOD_INC_USE_COUNT;
 	return 0;
@@ -427,7 +491,9 @@
 	for (i = 0; i < RTF_NO; i++) {
 		RTF_OPEN(i) = 0;
 	}
-
+#ifdef PROC_INFO
+	register_procinfo();
+#endif
 	return 0;
 }
 
@@ -443,6 +509,10 @@
 
 void cleanup_module(void)
 {
+
+#ifdef PROC_INFO
+	unregister_procinfo();
+#endif
 	unregister_chrdev(RTF_MAJOR, "rtf");
 }
 
